// ======================================================================= //
// Class Timer :
// (c) copyright PAC++ 1994
// date: 1994
// ======================================================================= //

#include <math.h>
extern "C" {
#include <sys/time.h>
#include <sys/resource.h>
  // int getrusage (int, struct rusage*) ; *** removed for g++ compiler
}
#include <iostream.h>
#include "timer.h"


   // Clear timer :
void Timer::clear() { ut = st = rt = 0 ; }

   // Start timer
void Timer::start()
{  
   struct rusage  tmp1 ;  // to getrusage (sys+user times)
   struct timeval tmp2 ;  // to gettimeofday  (real time)
   getrusage (RUSAGE_SELF, &tmp1) ; 
   gettimeofday (&tmp2, 0) ;

   // user time 
   ut = (double) tmp1.ru_utime.tv_sec + 
         ((double) tmp1.ru_utime.tv_usec)/ (double)MSPSEC ;
   // system time 
   st = (double) tmp1.ru_stime.tv_sec + 
         ((double) tmp1.ru_stime.tv_usec)/ (double)MSPSEC ;
   // real time 
   rt = (double) tmp2.tv_sec + 
         ((double) tmp2.tv_usec)/ (double)MSPSEC ; 
}

   // Stop timer 
void Timer::stop()
{ 
   double uts = ut, sts = st , rts = rt ;
   start() ;
   ut -= uts ; st -= sts ; rt -= rts ;
}

   // Return a value to initialize random generator 
long Timer::seed()   
{
   struct timeval tp;
   gettimeofday(&tp, 0) ;
   return(tp.tv_usec);
   return 1 ;
}

   // Output the value of the timer :
ostream& operator<<(ostream& o, const Timer& T) 
{
   o << "user time: " << T.usertime() << '\n' ;
   o << "sys. time: " << T.systime() << '\n' ;
   o << "real time: " << T.realtime() << endl ;
   return o ;
}
       
   // Some arithmetic operator :
Timer& Timer::operator = (const Timer & T) 
{  
   ut = T.ut ; st = T.st ; rt = T.rt ; 
   return *this ; 
}
      
   // Computes and returns interval of time
   // beteween *this and T
const Timer Timer::operator - (const Timer & T)  const
{
   Timer Tmp ;
   Tmp.ut = ut - T.ut ; 
   Tmp.st = st - T.st ; 
   Tmp.rt = rt - T.rt ; 
   return Tmp ;
}

const Timer Timer::operator - () 
{
   Timer Tmp ;
   Tmp.ut = -ut ; 
   Tmp.st = -st ; 
   Tmp.rt = -rt ; 
   return Tmp ;
}

const Timer Timer::operator + (const Timer & T)  const
{
   Timer Tmp ;
   Tmp.ut = ut + T.ut ; 
   Tmp.st = st + T.st ; 
   Tmp.rt = rt + T.rt ; 
   return Tmp ;
}


